package cz.muni.fi.pa165.catalog;

/**
 * Toto rozhrani reprezentuje katalog produktu.
 *
 * @author  Petr Adamek <petr.adamek@bilysklep.cz>
 */
public interface Catalog {
    
    /**
     * Tato metoda vrati korenovou skupinu katalogu.
     *
     * @return Korenovou skupinu katalogu
     */
    Group getRootGroup();
    
    /**
     * Tato metoda vytvori novou skupinu, ktera bude podskupinou skupiny parentGroup.
     * @return Nove vytvorena skupina
     * @param parentGroup Skupina, jejiz ma byt nova skupina podskupinou
     * @param name Jmeno nove skupiny
     * @throws CatalogException Jestlize vytvareni nove skupiny selze
     */
    Group newGroup(Group parentGroup, String name) throws CatalogException;
    
    /**
     * Tato metoda vytvori novy produkt, ktery bude zarazen do skupiny parentGroup.
     * @return Nove vytvoreny produkt
     * @param parentGroup Skupina, do niz ma byt novy produkt zarazen.
     * @param name Jmeno noveho produktu
     * @param price Cena noveho produktu
     * @throws CatalogException Jestlize vytvareni noveho produktu selze
     */
    Product newProduct(Group parentGroup, String name, double price) throws CatalogException;;
    
    /**
     * Tato metoda uzavre katalog. Pripadne zmeny jsou ulozeny.
     *
     * @throws CatalogException Jestlize ulozeni zmen nebo uvolneni prostredku asociovanych s katalogem selze.
     */
    void close() throws CatalogException;
}
